local BaikCore = LibStub("AceAddon-3.0"):GetAddon("BaikCore")
local Assert = BaikCore.Assert

-- Add Module to BaikCore
local Table = {}
BaikCore.Table = Table

-- Table API
function Table:Copy(table)
    Assert:Table(table)
    local newTable = {}
    for k, v in pairs(table) do newTable[k] = v end

    return setmetatable(newTable, getmetatable(table))
end

function Table:Size(table)
    Assert:Table(table)
    local count = 0
    for _ in pairs(table) do
        count = count + 1
    end

    return count
end

function Table:FindKey(table, value)
    Assert:Table(table)
    for tKey, tValue in pairs(table) do
        if tValue == value then
            return tKey
        end
    end
    return nil
end

function Table:Clear(table)
    Assert:Table(table)
    table = {}
end
